#include<stdio.h>
#include<stdlib.h>
#include<string.h>

typedef struct _osoba{

char ime[51];
char prezime[51];
char spol;
struct _osoba** prijatelji;
int brojPrijatelja;
int starost;
int brisati;
unsigned int oib;

}osoba;


int brisi(osoba* predavaonica, int brojOsoba){
    int num=0,i,j,k,z, pronasao=0, oib;

    for(i=0;i<brojOsoba;i++){
            pronasao=0;
            num=0;
            for(j=0;j<predavaonica[i].brojPrijatelja;j++){
                if(predavaonica[i].prijatelji[j]->spol=='m')
                        num++;
            }
                if(num>3){
                    pronasao=1;
                    predavaonica[i].brisati=1;
                }
    }

    for(i=0;i<brojOsoba;i++){
        if(predavaonica[i].brisati==1){
                oib=predavaonica[i].oib;

            for(j=0;j<predavaonica[i].brojPrijatelja;j++){
                for(k=0;k<predavaonica[i].prijatelji[j]->brojPrijatelja;k++)
                        if(predavaonica[i].prijatelji[j]->prijatelji[k]->oib==oib){
                               for(z=k+1;z<predavaonica[i].prijatelji[j]->brojPrijatelja;z++)
                                    predavaonica[i].prijatelji[j]->prijatelji[z-1]=predavaonica[i].prijatelji[j]->prijatelji[z];
                            predavaonica[i].prijatelji[j]->brojPrijatelja--;
                            break;
                        }
            }

            free(predavaonica[i].prijatelji);

            for(j=i+1;j<brojOsoba;j++)
                    predavaonica[j-1]=predavaonica[j];
                    i--;
                    brojOsoba--;
       }
    }
    return brojOsoba;
}


void ispisiSve(osoba* predavaonica, int brojOsoba){
    int i;

    for(i=0;i<brojOsoba;i++){
        printf("%s, %s, %u, %d\n",predavaonica[i].ime,predavaonica[i].prezime, predavaonica[i].oib,predavaonica[i].brojPrijatelja);
    }
}


void ispisiUvjet(osoba* predavaonica, int brojOsoba){

int i,j,k,z;
int presjek=0, unija=0,susjedi=0;
double postotak=0;

for(i=0;i<brojOsoba;i++){
    for(j=i+1;j<brojOsoba;j++){
            susjedi=0;
        presjek=0; unija=0;
        for(k=0;k<predavaonica[i].brojPrijatelja;k++)
            for(z=0;z<predavaonica[j].brojPrijatelja;z++){
                if(predavaonica[i].prijatelji[k]->oib==predavaonica[j].prijatelji[z]->oib){
                        presjek++;
                        break;
                }
            }

            unija=predavaonica[i].brojPrijatelja+predavaonica[j].brojPrijatelja-presjek;

            postotak=(double)presjek/(double)unija;
            if(postotak>=0.8)
                printf("( %s %s - %s %s )\n",predavaonica[i].ime,predavaonica[i].prezime,predavaonica[j].ime,predavaonica[j].prezime);
    }
  }
}


void oslobodiMemoriju(osoba* predavaonica, int brojOsoba){

    int i;

    for(i=0;i<brojOsoba;i++)
        free(predavaonica[i].prijatelji);

    free(predavaonica);

}

int main(void){


    char ime[51],prezime[51], spol;
    int godine;
    unsigned int oib;

    osoba* predavaonica=NULL;
    int brojOsoba=0;

    FILE *in = fopen("osobe.txt", "rt");
    if (in == NULL)
    {
        printf("Greska prilikom otvaranja datoteke za citanje\n");
        exit(1);
    }

    while(fscanf(in,"%[^;];%[^;];%c;%d;%u ",ime,prezime,&spol,&godine,&oib)==5){

          predavaonica=(osoba*) realloc(predavaonica,++brojOsoba*sizeof(osoba));
          strcpy(predavaonica[brojOsoba-1].ime,ime);
          strcpy(predavaonica[brojOsoba-1].prezime,prezime);
          predavaonica[brojOsoba-1].spol=spol;
          predavaonica[brojOsoba-1].starost=godine;
          predavaonica[brojOsoba-1].oib=oib;
          predavaonica[brojOsoba-1].brojPrijatelja=0;
          predavaonica[brojOsoba-1].prijatelji=NULL;
          predavaonica[brojOsoba-1].brisati=0;
    }

    fclose(in);

      FILE *in1 = fopen("prijateljstva.txt", "rt");
    if (in == NULL)
    {
        printf("Greska prilikom otvaranja datoteke za citanje\n");
        exit(1);
    }

    int oib1, oib2,i;

    while(fscanf(in1,"%d %d",&oib1,&oib2)==2){
        int ind1=-1, ind2=-1;
        for(i=0;i<brojOsoba;i++){
            if(predavaonica[i].oib==oib1)
                ind1=i;
            if(predavaonica[i].oib==oib2)
                ind2=i;
            if(ind1!=-1 && ind2!=-1)
                break;
        }

        predavaonica[ind1].prijatelji=(struct _osoba**) realloc(predavaonica[ind1].prijatelji,++predavaonica[ind1].brojPrijatelja*sizeof(osoba*));
        predavaonica[ind1].prijatelji[predavaonica[ind1].brojPrijatelja-1]=&predavaonica[ind2];

        predavaonica[ind2].prijatelji=(struct _osoba**) realloc(predavaonica[ind2].prijatelji,++predavaonica[ind2].brojPrijatelja*sizeof(osoba*));
        predavaonica[ind2].prijatelji[predavaonica[ind2].brojPrijatelja-1]=&predavaonica[ind1];
    }

    ispisiUvjet(predavaonica, brojOsoba);
    printf("\n\n");

    ispisiSve(predavaonica,brojOsoba);
    brojOsoba=brisi(predavaonica,brojOsoba);
    printf("\n\nmain - broj osoba: %d\n\n",brojOsoba);
    ispisiSve(predavaonica,brojOsoba);

    fclose(in1);
    oslobodiMemoriju(predavaonica,brojOsoba);

return 0;
}
