/*  Napisite funkciju prototipa  char* podniz(char** lista, int m)
koja vraca pokazivac na string, izgradjen od praznog stringa na sljedeci nacin.
Varijabla lista pokazuje na vec postojeci niz u kojem je zapisano m rijeci.
Korisnik upisuje rijeci (po jednu u redu), sve dok ne upise znak ?. Za svaku
ucitanu rijec a, funkcija podniz pretrazuje zadani niz od m rijeci i trazi
prvu rijec b, koja sadrzi rijec a. Ako nade takvu rijec b, onda tu rijec
treba dodati na kraj stringa koji se izgraduje, tako da je medu dodanim rijecima
po jedan razmak. U suprotnom, string se ne mijenja. Smijete pretpostaviti da ucitane
rijeci nemaju vise od 80 znakova.
Primjer: rijec a = dan sadrzana je u rijecima b=danas, predan, predanost. */

#include<stdio.h>
#include<stdlib.h>
#include<string.h>

int usporedi_podniz(char *a, char *b)
{
    int i,j,da=strlen(a), db=strlen(b), razlika=db-da;
    for(i=0;i<=razlika; i++){
        for(j=0;j<da;j++) if(a[j]!=b[i+j]) break;
        if(j==da) return 1;
    }
    return 0;
}


char* podniz(char **lista, int n)
{
    int i,t=0;              /*t sluzi da pri prvom upisu ne dodamo razmak*/
    char r[81];
    char *s; s=malloc(sizeof(char)); s[0]='\0';
    char c;
    while(1){
        scanf("%s",r);      scanf("%c",&c); /*cistimo ulaz od znaka za prijelaz u novi red*/
        if(strcmp(r,"#")==0) return s;
        for(i=0;i<n;i++) { if(usporedi_podniz(r,lista[i])) break; }
        if(i==n)  continue;
        s=realloc(s,(strlen(s)+1+t+strlen(lista[i]))*sizeof(char));
        if(t) strcat(s," "); strcat(s,lista[i]); t=1;
    }
    return s;
}


/*ostatak nije potreban za kolokvij*/


char** kreiraj(int *n)
{
    *n=0;
    char r[15];
    char **p=NULL;
    char c;
    while(1){
        scanf("%s",r);  scanf("%c",&c);  /*ciscenje ulaza od znaka za novi red*/
        if(strcmp(r,"#")==0) return p;
        ++(*n);
        p=realloc(p,(*n)*sizeof(char*));
        p[*n-1]=realloc(p[*n-1],(strlen(r)+1)*sizeof(char));
        p[*n-1][0]='\0';
        strcat(p[*n-1],r);
    }
    return p;
}

int main (void)
{
    int n;
    char **p=kreiraj(&n),*s;
    s=podniz(p,n);
    printf("kreirani niz je \n%s",s);
    return 0;
}


