#include <stdio.h>
#include <string.h>

typedef struct
{
    char tel[16];
    char ime[51];
    int ocjena;
} glas;

typedef struct
{
    int broj;
    int uk_ocjena;
    char ime[51];
} natjecatelj;

int indexNatjecatelja(const char *ime, natjecatelj *niz, int *n)
{
    int i;
    for (i = 0; i < *n; ++i)
        if (!strcmp(ime, niz[i].ime))
            return i;
    strcpy(niz[i].ime, ime);
    niz[i].broj = 0;
    niz[i].uk_ocjena = 0;
    *n = i+1;
    return i;
}

int main()
{
    FILE *in = fopen("glasanje.dat", "rb");
    FILE *out = fopen("natjecatelji.txt", "wt");
    natjecatelj niz[200];
    glas G;
    int i, j, n = 0;

    while (fread(&G, 1, sizeof(glas), in))
    {
        i = indexNatjecatelja(G.ime, niz, &n);
        niz[i].broj++;
        niz[i].uk_ocjena += G.ocjena;
    }

    for (i = 0; i < n; ++i)
        for (j = i+1; j < n; ++j)
            if ( niz[i].uk_ocjena*niz[j].broj <
                 niz[j].uk_ocjena*niz[i].broj )
            {
                natjecatelj tmp;
                tmp = niz[i]; niz[i] = niz[j]; niz[j] = tmp;
            }

    for (i = 0; i < n; ++i)
        fprintf(out, "%s: %.3lf\n", niz[i].ime,
                (double)niz[i].uk_ocjena/niz[i].broj);

    fclose(in);
    fclose(out);
    return 0;
}
