#include<stdio.h>
#include<stdlib.h>
#include<string.h>

typedef struct _osoba{

char ime[51];
char prezime[51];
char spol;
struct _osoba** prijatelji;
int brojPrijatelja;
int starost;
int brisati;
unsigned int oib;

}osoba;


int brisi(osoba* igraonica, int brojOsoba){
    int num=0,i,j,k,z, pronasao=0, oib;

    for(i=0;i<brojOsoba;i++){
            pronasao=0;
            num=0;
            for(j=0;j<igraonica[i].brojPrijatelja;j++){
                if(igraonica[i].prijatelji[j]->starost<30)
                        num++;
            }
                if(num<5){
                    pronasao=1;
                    igraonica[i].brisati=1;
                }
    }

    for(i=0;i<brojOsoba;i++){
        if(igraonica[i].brisati==1){
                oib=igraonica[i].oib;

            for(j=0;j<igraonica[i].brojPrijatelja;j++){
                for(k=0;k<igraonica[i].prijatelji[j]->brojPrijatelja;k++)
                        if(igraonica[i].prijatelji[j]->prijatelji[k]->oib==oib){
                               for(z=k+1;z<igraonica[i].prijatelji[j]->brojPrijatelja;z++)
                                    igraonica[i].prijatelji[j]->prijatelji[z-1]=igraonica[i].prijatelji[j]->prijatelji[z];
                            igraonica[i].prijatelji[j]->brojPrijatelja--;
                            break;
                        }
            }

            free(igraonica[i].prijatelji);

            for(j=i+1;j<brojOsoba;j++)
                    igraonica[j-1]=igraonica[j];
                    i--;
                    brojOsoba--;
       }
    }
    return brojOsoba;
}


void ispisiSve(osoba* igraonica, int brojOsoba){
    int i;

    for(i=0;i<brojOsoba;i++){
        printf("%s, %s, %u, %d\n",igraonica[i].ime,igraonica[i].prezime, igraonica[i].oib,igraonica[i].brojPrijatelja);
    }
}


void ispisiUvjet(osoba* igraonica, int brojOsoba){

int i,j,k,z;
int presjek=0, unija=0,susjedi=0;
double postotak=0;

for(i=0;i<brojOsoba;i++){
    for(j=i+1;j<brojOsoba;j++){
            susjedi=0;
        presjek=0; unija=0;
        for(k=0;k<igraonica[i].brojPrijatelja;k++)
            for(z=0;z<igraonica[j].brojPrijatelja;z++){
                if(igraonica[i].prijatelji[k]->oib==igraonica[j].prijatelji[z]->oib && igraonica[j].prijatelji[z]->spol=='z'){
                        presjek++;
                        break;
                }
            }

            if(presjek>0)
                printf("( %s %s - %s %s )\n",igraonica[i].ime,igraonica[i].prezime,igraonica[j].ime,igraonica[j].prezime);
    }
  }
}


void oslobodiMemoriju(osoba* igraonica, int brojOsoba){

    int i;

    for(i=0;i<brojOsoba;i++)
        free(igraonica[i].prijatelji);

    free(igraonica);

}

int main(void){


    char ime[51],prezime[51], spol;
    int godine;
    unsigned int oib;

    osoba* igraonica=NULL;
    int brojOsoba=0;

    FILE *in = fopen("osobe.txt", "rt");
    if (in == NULL)
    {
        printf("Greska prilikom otvaranja datoteke za citanje\n");
        exit(1);
    }

    while(fscanf(in,"%[^;];%[^;];%c;%d;%u ",ime,prezime,&spol,&godine,&oib)==5){

          igraonica=(osoba*) realloc(igraonica,++brojOsoba*sizeof(osoba));
          strcpy(igraonica[brojOsoba-1].ime,ime);
          strcpy(igraonica[brojOsoba-1].prezime,prezime);
          igraonica[brojOsoba-1].spol=spol;
          igraonica[brojOsoba-1].starost=godine;
          igraonica[brojOsoba-1].oib=oib;
          igraonica[brojOsoba-1].brojPrijatelja=0;
          igraonica[brojOsoba-1].prijatelji=NULL;
          igraonica[brojOsoba-1].brisati=0;
    }

    fclose(in);

      FILE *in1 = fopen("prijateljstva.txt", "rt");
    if (in == NULL)
    {
        printf("Greska prilikom otvaranja datoteke za citanje\n");
        exit(1);
    }

    int oib1, oib2,i;

    while(fscanf(in1,"%d %d",&oib1,&oib2)==2){
        int ind1=-1, ind2=-1;
        for(i=0;i<brojOsoba;i++){
            if(igraonica[i].oib==oib1)
                ind1=i;
            if(igraonica[i].oib==oib2)
                ind2=i;
            if(ind1!=-1 && ind2!=-1)
                break;
        }

        igraonica[ind1].prijatelji=(struct _osoba**) realloc(igraonica[ind1].prijatelji,++igraonica[ind1].brojPrijatelja*sizeof(osoba*));
        igraonica[ind1].prijatelji[igraonica[ind1].brojPrijatelja-1]=&igraonica[ind2];

        igraonica[ind2].prijatelji=(struct _osoba**) realloc(igraonica[ind2].prijatelji,++igraonica[ind2].brojPrijatelja*sizeof(osoba*));
        igraonica[ind2].prijatelji[igraonica[ind2].brojPrijatelja-1]=&igraonica[ind1];
    }

    ispisiUvjet(igraonica, brojOsoba);
    printf("\n\n");

    ispisiSve(igraonica,brojOsoba);
    brojOsoba=brisi(igraonica,brojOsoba);
    printf("\n\nmain - broj osoba: %d\n\n",brojOsoba);
    ispisiSve(igraonica,brojOsoba);

    fclose(in1);
    oslobodiMemoriju(igraonica,brojOsoba);

return 0;
}
